.include "r8c-33c.inc"

	.section ".vec", "a"
	.3byte	0	; UND
	.byte	0xff
	.3byte	0	; overflow
	.byte	0xff
	.3byte	0	; BRK, see also ivect
	.byte	0xff

	.section ".resetvec", "a"
	.global	_reset
_reset:
	.3byte	_start
	.byte	0xff		; watchdog settings.

	.text

leds:
	.byte	0x4f, 0x2f, 0x1f
leds_end:

	.global _start
_start:
	mov.b	#0xff, prcr
	mov.b	#0x9f, pd1
	mov.b	#0x07, pd2

; Fire up the external crystal
	mov.b	#0x01, prcr
	mov.b	#0x08, cm0
	mov.b	#0x38, cm1
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	mov.b	#0x00, ocd
	mov.b	#0x08, cm0
	mov.b	#0x00, prcr

	mov.b	#0xff, prcr
	mov.b	#0xff, pd0
	mov.w	#0x0f0f, a1

loop_reset:	
	mov.w	#leds, a0

loop_top:
	mov.w	#0, r0
1:	adjnz.w	#1, r0, 1b
	
	mov.b	[a0], r1l
	mov.b	r1l, r1h

	and.b	#0x0f, r1l
	mov.b	r1l, p1
	rot.b	#4, r1h
	mov.b	r1h, p2
	mov.b	a1, p0
	rot.b	#1, a1

	mov.w	#9, r2
2:	mov.w	#0, r0
1:	adjnz.w	#1, r0, 1b
	adjnz.w	#-1, r2, 2b

	add.w	#1, a0
	cmp.w	#leds_end, a0
	jne	loop_top
	jmp.b	loop_reset

	.bss
